#ifndef _ASCII_H
#	define _ASCII_H
#	define ASCII_MAX_VALUE 0x7f

#	define ASCII_ALPHA_UPPER "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#	define ASCII_ALPHA_LOWER "abcdefghijklmnopqrstuvwxyz"

#	define ASCII_BINARY_DIGITS_UPPER "01"
#	define ASCII_BINARY_DIGITS_LOWER ASCII_BINARY_DIGITS_UPPER

#	define ASCII_OCTAL_DIGITS_UPPER ASCII_BINARY_DIGITS_UPPER "234567"
#	define ASCII_OCTAL_DIGITS_LOWER ASCII_OCTAL_DIGITS_UPPER

#	define ASCII_DECIMAL_DIGITS_UPPER ASCII_OCTAL_DIGITS_UPPER "89"
#	define ASCII_DECIMAL_DIGITS_LOWER ASCII_DECIMAL_DIGITS_UPPER

#	define ASCII_HEXADECIMAL_DIGITS_UPPER \
		ASCII_DECIMAL_DIGITS_UPPER "ABCDEF"
#	define ASCII_HEXADECIMAL_DIGITS_LOWER \
		ASCII_DECIMAL_DIGITS_UPPER "abcdef"

#	define ASCII_CHAR_NAMES { \
/*   0 */	"NUL", "SOH", "STX", "ETX", \
/*   4 */	"EOT", "ENQ", "ACK", "BEL", \
/*   8 */	"BS", "HT", "LF", "VT", \
/*  12 */	"FF", "CR", "SO", "SI", \
/*  16 */	"DLE", "DC1", "DC2", "DC3", \
/*  20 */	"DC4", "NAK", "SYN", "ETB", \
/*  24 */	"CAN", "EM", "SUB", "ESC", \
/*  28 */	"FS", "GS", "RS", "US", \
/*  32 */	"SP", "EXCLAMATION_MARK", "QUOTATION_MARK", "NUMBER_SIGN", \
/*  36 */	"CURRENCY_SIGN", "PERCENT_SIGN", "AMPERSAND", "APOSTROPHE", \
/*  40 */	"LEFT_PARENTHESIS", "RIGHT_PARENTHESIS", "ASTERISK", "PLUS_SIGN", \
/*  44 */	"COMMA", "HYPHEN", "FULL_STOP", "SOLIDUS", \
/*  48 */	"0", "1", "2", "3", \
/*  52 */	"4", "5", "6", "7", \
/*  56 */	"8", "9", "COLON", "SEMICOLON", \
/*  60 */	"LESS_THAN_SIGN", "EQUALS_SIGN", "GREATER_THAN_SIGN", "QUESTION_MARK", \
/*  64 */	"COMMERCIAL_AT", "A", "B", "C", \
/*  68 */	"D", "E", "F", "G", \
/*  72 */	"H", "I", "J", "K", \
/*  76 */	"L", "M", "N", "O", \
/*  80 */	"P", "Q", "R", "S", \
/*  84 */	"T", "U", "V", "W", \
/*  88 */	"X", "Y", "Z", "LEFT_SQUARE_BRACKET", \
/*  92 */	"REVERSED_SOLIDUS", "RIGHT_SQUARE_BRACKET", "CIRCUMFLEX_ACCENT", "LOW_LINE", \
/*  96 */	"GRAVE_ACCENT", "a", "b", "c", \
/* 100 */	"d", "e", "f", "g", \
/* 104 */	"h", "i", "j", "k", \
/* 108 */	"l", "m", "n", "o", \
/* 112 */	"p", "q", "r", "s", \
/* 116 */	"t", "u", "v", "w", \
/* 120 */	"x", "y", "z", "LEFT_CURLY_BRACKET", \
/* 124 */	"VERTICAL_LINE", "RIGHT_CURLY_BRACKET", "OVERLINE", "DELETE" \
};

enum{
/*   0 */	ASCII_NUL, ASCII_SOH, ASCII_STX, ASCII_ETX,
/*   4 */	ASCII_EOT, ASCII_ENQ, ASCII_ACK, ASCII_BEL,
/*   8 */	ASCII_BS, ASCII_HT, ASCII_LF, ASCII_VT,
/*  12 */	ASCII_FF, ASCII_CR, ASCII_SO, ASCII_SI,
/*  16 */	ASCII_DLE, ASCII_DC1, ASCII_DC2, ASCII_DC3,
/*  20 */	ASCII_DC4, ASCII_NAK, ASCII_SYN, ASCII_ETB,
/*  24 */	ASCII_CAN, ASCII_EM, ASCII_SUB, ASCII_ESC,
/*  28 */	ASCII_FS, ASCII_GS, ASCII_RS, ASCII_US,
/*  32 */	ASCII_SP, ASCII_EXCLAMATION_MARK, ASCII_QUOTATION_MARK, ASCII_NUMBER_SIGN, 
/*  36 */	ASCII_CURRENCY_SIGN, ASCII_PERCENT_SIGN, ASCII_AMPERSAND, ASCII_APOSTROPHE,
/*  40 */	ASCII_LEFT_PARENTHESIS, ASCII_RIGHT_PARENTHESIS, ASCII_ASTERISK, ASCII_PLUS_SIGN,
/*  44 */	ASCII_COMMA, ASCII_HYPHEN, ASCII_FULL_STOP, ASCII_SOLIDUS,
/*  48 */	ASCII_0, ASCII_1, ASCII_2, ASCII_3,
/*  52 */	ASCII_4, ASCII_5, ASCII_6, ASCII_7,
/*  56 */	ASCII_8, ASCII_9, ASCII_COLON, ASCII_SEMICOLON,
/*  60 */	ASCII_LESS_THAN_SIGN, ASCII_EQUALS_SIGN, ASCII_GREATER_THAN_SIGN, ASCII_QUESTION_MARK,
/*  64 */	ASCII_COMMERCIAL_AT, ASCII_A, ASCII_B, ASCII_C,
/*  68 */	ASCII_D, ASCII_E, ASCII_F, ASCII_G,
/*  72 */	ASCII_H, ASCII_I, ASCII_J, ASCII_K,
/*  76 */	ASCII_L, ASCII_M, ASCII_N, ASCII_O,
/*  80 */	ASCII_P, ASCII_Q, ASCII_R, ASCII_S,
/*  84 */	ASCII_T, ASCII_U, ASCII_V, ASCII_W,
/*  88 */	ASCII_X, ASCII_Y, ASCII_Z, ASCII_LEFT_SQUARE_BRACKET,
/*  92 */	ASCII_REVERSED_SOLIDUS, ASCII_RIGHT_SQUARE_BRACKET, ASCII_CIRCUMFLEX_ACCENT, ASCII_LOW_LINE,
/*  96 */	ASCII_GRAVE_ACCENT, ASCII_a, ASCII_b, ASCII_c,
/* 100 */	ASCII_d, ASCII_e, ASCII_f, ASCII_g,
/* 104 */	ASCII_h, ASCII_i, ASCII_j, ASCII_k,
/* 108 */	ASCII_l, ASCII_m, ASCII_n, ASCII_o,
/* 112 */	ASCII_p, ASCII_q, ASCII_r, ASCII_s,
/* 116 */	ASCII_t, ASCII_u, ASCII_v, ASCII_w,
/* 120 */	ASCII_x, ASCII_y, ASCII_z, ASCII_LEFT_CURLY_BRACKET,
/* 124 */	ASCII_VERTICAL_LINE, ASCII_RIGHT_CURLY_BRACKET, ASCII_OVERLINE, ASCII_DELETE
};
#endif /* ifndef _ASCII_H */
