# dmenubar - dynamic menu bar

dmenu is an efficient dynamic menu for X.
dmenubar is a hack on dmenu that displays a menu bar.

![Screenshot of dmenubar displaying "Pretty cool!", as input in the terminal.](screenshot.png)
## Why

lemonbar [can't do TTF fonts](https://github.com/LemonBoy/bar/issues/188).

dmenubar intends to be a knockoff of lemonbar that can do TTF, basically.
I tore out a ton of the dmenu code, made stdin feed into the dmenu prompt, and
presto flavo. Code's not great but dmenubar.c (where most of the changes are)
is only ~300 lines so it could be worse.

## You shouldn't use this

If you use any features of lemonbar outside of the default settings you
probably won't be able to make dmenubar fit your workflow. Cosmetically, dmenu
lets you change the font and colors and whether it's on the top or the bottom
of the screen and that's about it.

The biggest issue is dmenubar draws *over* other windows the same way dmenu
does. I have my keybindings like this in sxhkd so I can pull up dmenubar and
then kill it when I'm done looking:

```
mod1 + i
        ps x | grep dmenubar | grep -v grep && pkill dmenubar; \
        show_bar_stuff | /home/trinity/src/dmenubar/dmenubar -b

mod1 + shift + i
        pkill dmenubar
```

*Maybe* somebody will prefer this over how lemonbar does it? I don't know.

## Requirements

In order to build dmenu you need the Xlib header files.

On Alpine Linux:

```
apk add libx11-dev libxinerama-dev libxft-dev
```

## Installation

Edit config.mk to match your local setup (dmenu is installed into
the /usr/local namespace by default).

Afterwards enter the following command to build and install dmenu
(if necessary as root):

`make clean install`
