#include <errno.h> /* EACCESS, ELOOP, ENAMETOOLONG, ENOENT, ENOTDIR, errno */
#include <stdio.h> /* fprintf(3) */
#include <stdlib.h> /* stderr */
#include <string.h> /* strerror(3) */
#include <sysexits.h> /* EX_OSERR, EX_NOPERM, EX_NOINPUT, EX_UNAVAILABLE,
                       * EX_USAGE */
#include <unistd.h> /* chdir(2) */

static char *program_name = "pschdir";

int main(int argc, char *argv[]){

	if(argc < 3){
		fprintf(stderr,
			"Usage: %s [directory] [command (argument...)]\n",
			argv[0] == NULL ? program_name : argv[0]);
		return EX_USAGE;
	}

	if(chdir(argv[1]) != 0){
		fprintf(stderr, "%s: %s: %s\n", argv[0], argv[1],
			strerror(errno));
		switch(errno){
		case EACCES:	return EX_NOPERM;
		case ELOOP:	return EX_UNAVAILABLE;
		case ENAMETOOLONG:	return EX_OSERR;
		case ENOENT:	return EX_NOINPUT;
		case ENOTDIR:	return EX_NOINPUT;
		default:	return EX_UNAVAILABLE;
		}
	}

	execvp(argv[2], argv + 2);
}
