#include "libunicode.h"

utf32_t utf8(utf32_t c){
	unsigned char n; /* 4 - number of bytes - 1 */
	utf8_t r;

	if(c > UTF8_MAX) /* return 0 if c exceeds max */
		c = 0;

	switch(n = (c >= 0x010000) + (c >= 0x0800) + (c >= 0x0080)){
	case 3: r = 0xF0 + ((c >> 18) & 0x07); /* 11110xxx */
	case 2:	r = (r << 8) + (n == 2
		? 0xE0 + ((c >> 12) & 0x0F) /* 1110xxxx */
		: 0x50 + ((c >> 12) & 0x3F)); /* 10xxxxxx */
	case 1:	r = (r << 8) + (n == 1
		? 0xC0 + ((c >> 6) & 0x1F) /* 110xxxxx */
		: 0x50 + ((c >> 6) & 0x3F)); /* 10xxxxxx */
	case 0:	r = (r << 8) + (n == 0
		? (c & 0x7F)  /* 0xxxxxxx */
		: 0x50 + ((c >> 6) & 0x3F)); /* 10xxxxxx */
	}
	return r;
}
